Subject: bug#26911: 25.2; eshell "cd .." doesn't work correctly with TRAMP

From: Eli Zaretskii <[email-masked]>
Date: Sun, 30 Aug 2020 17:14:46 +0300

> From: Michael Albinus <[email-masked]>
> Cc: [email-masked],  [email-masked],  [email-masked],
>   [email-masked]
> Date: Sun, 30 Aug 2020 11:46:53 +0200
> 
> >   Test tramp-test05-expand-file-name condition:
> >       (ert-test-failed
> >        ((should
> > 	 (string-equal
> > 	  (expand-file-name "/method:host:/path/.")
> > 	  (if ... "/method:host:/path/" "/method:host:/path")))
> > 	:form
> > 	(string-equal "/method:host:/path" "/method:host:/path/")
> > 	:value nil))
> >      FAILED  12/70  tramp-test05-expand-file-name (0.000000 sec)
> 
> This is as expected, thanks.
> 
> I'm a little bit undecided whether I do special-case the test for
> running on MS Windows, or whether I wait that it will be fixed. WDYT?

IMO, special-casing a test is only a good idea if that is done for
reasons unrelated to the behavior being tested.  It makes no sense to
me to special-case a test in order to make failure look like success.
It's a slippery slope: once we go that way, before long we will have
to special-case real code, where the problematic behavior matters.

There's no real reason to special-case Windows in this case, because
its behavior doesn't really differ that much from Posix.  There's a
small difference in syntax, but the concepts are all the same.

We should fix this, not paper over it.